---
title: "Project 1"
output: html_document
---
Name: Kelven Rahy
ID: 201801014


## Introduction

In this article we will do a complete (Affymetrix) microarray analysis, including data import, preprocessing, differential expression and enrichment analysis.

The data set used is from a paper studying the differences in gene expression in 4 groups ovarian cells, each treated differently. They wanted to study the difference between the first 2 samples (null-vector control plasmid (OVCAR8-NV) versus HE4 overexpression plasmid (OVCAR8-C5)) and then the difference between 2 other samples (untreated wild type (OVCAR8-WT) versus wild type treated with recombinant HE4 (OVCAR8-WT-rHE4)). Each samples contains 3 independent experiments. The results show a substantial overlap with the results of the original paper.
Data is from Ribeiro et. al on ArrayExpress.


## Workflow package installation

```{r}
    library(devtools)
    library(remotes)
    suppressPackageStartupMessages({library("maEndToEnd")})
#General Bioconductor packages
    library(Biobase)
    library(oligoClasses)
     
#Annotation and data import packages
    library(ArrayExpress)
    library(pd.hugene.1.0.st.v1)
    library(hugene10sttranscriptcluster.db)
     
#Quality control and pre-processing packages
    library(oligo)
    library(arrayQualityMetrics)
     
#Analysis and statistics packages
    library(limma)
    library(topGO)
    library(ReactomePA)
    library(clusterProfiler)
     
#Plotting and color options packages
    library(gplots)
    library(ggplot2)
    library(geneplotter)
    library(RColorBrewer)
    library(pheatmap)
     
#Formatting/documentation packages
   #library(rmarkdown)
   #library(BiocStyle)
    library(dplyr)
    library(tidyr)

#Helpers:
    library(stringr)
    library(matrixStats)
    library(genefilter)
    library(openxlsx)
   #library(devtools)
```



## Downloading the raw data from ArrayExpress

The first step of the analysis is to download the raw data CEL files. We will store these files in the directory raw_data_dir which defaults to a temporary directory.
```{r}
raw_data_dir <- "C:/Users/ooo/Desktop/k/Uni/Fall 2020/Functional Genomics/Project 1"

if (!dir.exists(raw_data_dir)) {
    dir.create(raw_data_dir)
}

#anno_AE <- getAE("E-MTAB-6366", path = raw_data_dir, type = "raw")
```



## Import of annotation data and microarray expression data as “ExpressionSet”

Import the SDRF file:
```{r}
sdrf_location <- file.path(raw_data_dir, "E-MTAB-6366.sdrf.txt")
SDRF <- read.delim(sdrf_location)

rownames(SDRF) <- SDRF$Array.Data.File
SDRF <- AnnotatedDataFrame(SDRF)
```

We now create the Expression Set object raw_data, which contains array data, pheno data (from the SDRF file) as well as the information of the chip annotation package used.
```{r}
raw_data <- oligo::read.celfiles(filenames = file.path(raw_data_dir, 
                                                SDRF$Array.Data.File),
                                    verbose = FALSE, phenoData = SDRF)
stopifnot(validObject(raw_data))
```

The pData function of the Biobase package directly accesses the phenoData in the ExpressionSet raw_data. We have a look at the columns included and retain only those columns that are related to the experimental factors of interest.
```{r}
head(Biobase::pData(raw_data))
```

Since the column Assay.Name doesnt not differentiate between untreated wild type phenotype and wild type phenotype treated with rHE4,the code will take them as 3 groups instead of 4:
```{r}
Biobase::pData(raw_data)[,30]
```
Here, only the last 3 are untreated wild type phenotype, whereas the 3 before them were treated with rHE4, so we edit them such that there's a difference between the 2 groups:
```{r}
Biobase::pData(raw_data)[7, 30]="wild type phenotype HE4"
Biobase::pData(raw_data)[8, 30]="wild type phenotype HE4"
Biobase::pData(raw_data)[9, 30]="wild type phenotype HE4"
```

The columns of interest for us are the following:
* identifiers of the individuals, i.e. columns “Source.Name”, “Assay.Name”
* cell experiment type, i.e. “Factor.Value.phenotype.”
We now subselect the corresponding columns:
```{r}
Biobase::pData(raw_data) <- Biobase::pData(raw_data)[, c("Source.Name", "Assay.Name",
                                                         "Factor.Value.phenotype.")]
```



## Quality control of the raw data

Here we check for outliers and try to see whether the data clusters as expected, e.g. by the experimental conditions. The rows represent the microarray probes, i.e. the single DNA locations on the chip, while the columns represent one microarray, i.e. a sample of inflamed and non-inflamed tissue of every patient, respectively.
```{r}
Biobase::exprs(raw_data)[1:5, 1:5]
```

For quality control, we take the log2 of Biobase::exprs(raw_data), as expression data is commonly analyzed on a logarithmic scale.

We then perform 2 principal component analysis (PCA) and plot them, the first for OVCAR8-NV vs OVCAR8-C5, and the second for OVCAR8-WT vs OVCAR8-WT-rHE4 samples.

OVCAR8-NV & OVCAR8-C5:
```{r}
exp_raw <- log2(Biobase::exprs(raw_data))
PCA_raw <- prcomp(t(exp_raw), scale. = FALSE)

percentVar <- round(100*PCA_raw$sdev^2/sum(PCA_raw$sdev^2),1)
sd_ratio <- sqrt(percentVar[2] / percentVar[1])

dataGG <- data.frame(PC1 = PCA_raw$x[,1], PC2 = PCA_raw$x[,2],
                   Phenotype = pData(raw_data)$Factor.Value.phenotype.,
                    Individual = pData(raw_data)$Source.Name)

ggplot(dataGG[1:6,], aes(PC1, PC2)) +
      geom_point(aes(colour = Phenotype)) +
  ggtitle("PCA plot of the log-transformed raw expression data
          for OVCAR8-NV and OVCAR8-C5") +
  xlab(paste0("PC1, VarExp: ", percentVar[1], "%")) +
  ylab(paste0("PC2, VarExp: ", percentVar[2], "%")) +
  theme(plot.title = element_text(hjust = 0.5))+
  coord_fixed(ratio = sd_ratio) +
  scale_shape_manual(values = c(4,15)) + 
  scale_color_manual(values = c("#058ED9", "#F17300"))
```

OVCAR8-WT vs OVCAR8-WT-rHE4:
```{r}
percentVar <- round(100*PCA_raw$sdev^2/sum(PCA_raw$sdev^2),1)
sd_ratio <- sqrt(percentVar[2] / percentVar[1])

dataGG <- data.frame(PC1 = PCA_raw$x[,1], PC2 = PCA_raw$x[,2],
                   Phenotype = pData(raw_data)$Factor.Value.phenotype.,
                    Individual = pData(raw_data)$Source.Name)

ggplot(dataGG[7:12,], aes(PC1, PC2)) +
      geom_point(aes(colour = Phenotype)) +
  ggtitle("PCA plot of the log-transformed raw expression data
          for OVCAR8-WT and OVCAR8-WT-rHE4") +
  xlab(paste0("PC1, VarExp: ", percentVar[1], "%")) +
  ylab(paste0("PC2, VarExp: ", percentVar[2], "%")) +
  theme(plot.title = element_text(hjust = 0.5))+
  coord_fixed(ratio = sd_ratio) +
  scale_shape_manual(values = c(4,15)) + 
  scale_color_manual(values = c("#EC368D", "#071013"))
```

In both graphs, there are no clear clusters.


We also represent the probe intensities via a boxplot graph with one box per individual microarray:
```{r}
oligo::boxplot(raw_data, target = "core", 
               main = "Boxplot of log2-intensitites for the raw data")
```

We now produce an html report, containing the quality control plots together with a description of their aims and an identification of possible outliers:
```{r}
arrayQualityMetrics(expressionset = raw_data,
  outdir = "C:/Users/ooo/Desktop/k/Uni/Fall 2020/Functional Genomics/Project 1",
   force = TRUE, do.logtransform = TRUE,
    intgroup = c("Factor.Value.phenotype."))
```



## Relative Log Expression data quality analysis


Before calibrating and evaluating the data, we want to perform another quality control procedure, namely Relative Log Expression (RLE), as described in the article by Gandolfo et al (9). To this end, we first perform an RMA without prior normalization:
```{r}
ribeiro_eset <- oligo::rma(raw_data, target = "core", normalize = FALSE)
```

The RLE is performed by calculating the median log2 intensity of every transcript across all arrays.
We do this by calculating the row medians of exprs(ribeiro_eset), as the transcripts are represented by the rows and the single microarrays by the columns.
Note that we do not have to apply the log2 manually, as the output data of the RMA function is in log2 scale by default.
We then substract this transcript median intensity from every transcript intensity via the sweep function.
We finally reshape the data into a format in which we can use to create a boxplot for each array, as before:

```{r}
row_medians_assayData <- 
  Biobase::rowMedians(as.matrix(Biobase::exprs(ribeiro_eset)))

RLE_data <- sweep(Biobase::exprs(ribeiro_eset), 1, row_medians_assayData)

RLE_data <- as.data.frame(RLE_data)
RLE_data_gathered <- 
  tidyr::gather(RLE_data, patient_array, log2_expression_deviation)

ggplot2::ggplot(RLE_data_gathered, aes(patient_array,
                                       log2_expression_deviation)) + 
  geom_boxplot(outlier.shape = NA) + 
  ylim(c(-2, 2)) + 
  theme(axis.text.x = element_text(colour = "aquamarine4", 
                                  angle = 60, size = 6.5, hjust = 1 ,
                                  face = "bold"))
```
Note that the y-axis now displays for each microarray the deviation of expression intensity from the median expression of the respective single transcripts across arrays.

Boxes with a larger extension therefore indicate an unusually high deviation from the median in a lot of transcripts, suggesting that these arrays are different from most of the others in some way.

Boxes that are shifted in y-direction indicate a systematically higher or lower expression of the majority of transcripts in comparison to most of the other arrays. This could be caused by quality issues or batch effects.

By inspecting the boxplot, 2 arrays could be considered as outliers: 090215JR14.CEL 090215JR17.CEL are positively shifted.



## RMA calibration of the data


First step of RMA is the background normalization of the data:
```{r}
library(preprocessCore)
bg_corrected_data=rma.background.correct(exprs(raw_data))
```

Next, the quantile normalization step:
```{r}
  
  # For ranking, sorting, accessing and manipulating rows and columns:
  # We focus on using apply() family methods instead of for loops to optimize speed
  
  # ranked cols matrix: Contains Expressions-> Ranks in their matrix
  ranked_cols_matrix <- apply(bg_corrected_data,2, rank,ties.method="min")
  
  # we can use apply(data,2,sort) to get the sorted matrix by columns
  sorted_cols_matrix <- apply(bg_corrected_data, 2, sort)

  # Get the mean of every row in the sorted_cols_matrix
  mean_by_row <- rowMeans(sorted_cols_matrix)
  
 
  replace_w_means <- function(column, means){
    # Rank-Frequency table: Gets all repeated expressions and their frequency
    rank_freq <- data.frame(table(column))
    rank_freq <- as.matrix(rank_freq)
    
    # Function to update row means into row means but column specific, check below for more...
    update_mean <- function(rf, med){
    new_mean <- rep(mean(med[as.integer(rf[1]):(as.integer(rf[1])+as.integer(rf[2])-1)]),rf[2])
    return (new_mean)
    }
    # All Repeated Ranks will influence the means => replace the means with average of means
    new_means <- apply(rank_freq,1, update_mean, med=mean_by_row)
    new_means <- unlist(new_means)
    
    # Index to mean function: Replace all values with rank x with average mean of the same rank
    index_to_mean <- function(my_index, my_mean){
    return(my_mean[my_index])
    }
    # Apply index_to_mean on column X
    final_result <- lapply(column, index_to_mean, my_mean=new_means)
    final_result <- unlist(final_result)
  
    return(final_result)
}
 # Apply replace_w_means to every column of the matrix:
  quantile_normalized  <- apply(ranked_cols_matrix,2,replace_w_means, means=mean_by_row)
 
```

Now, we compare the results of the built-in quantile normalization function to the one above:

```{r}
built_in_quantile=normalize.quantiles(bg_corrected_data)
diff= head(built_in_quantile)-head(quantile_normalized)
diff
```
As we can see, the differences are minor, almost negligible.

However, we will work with the built-in function which includes all 3 steps of RMA.

```{r}
ribeiro_eset_norm <- oligo::rma(raw_data, target = "core")
```

*PCA analysis*

First, we perform a PCA analysis of the calibrated data analogously to the one with the raw data; again, we have 2 groups:

OVCAR8-NV & OVCAR8-C5:
```{r}
exp_ribeiro <- Biobase::exprs(ribeiro_eset_norm)
PCA <- prcomp(t(exp_ribeiro), scale = FALSE)

percentVar <- round(100*PCA$sdev^2/sum(PCA$sdev^2),1)
sd_ratio <- sqrt(percentVar[2] / percentVar[1])

dataGG <- data.frame(PC1 = PCA_raw$x[,1], PC2 = PCA_raw$x[,2],
                     Phenotype = pData(raw_data)$Factor.Value.phenotype.,
                    Individual = pData(raw_data)$Source.Name)


ggplot(dataGG[1:6,], aes(PC1, PC2)) +
      geom_point(aes(colour = Phenotype)) +
  ggtitle("PCA plot of the calibrated, summarized data") +
  xlab(paste0("PC1, VarExp: ", percentVar[1], "%")) +
  ylab(paste0("PC2, VarExp: ", percentVar[2], "%")) +
  theme(plot.title = element_text(hjust = 0.5)) +
  coord_fixed(ratio = sd_ratio) +
  scale_shape_manual(values = c(4,15)) + 
  scale_color_manual(values = c("#058ED9", "#F17300", "#EC368D", "#071013"))
```

OVCAR8-WT vs OVCAR8-WT-rHE4:
```{r}
exp_ribeiro <- Biobase::exprs(ribeiro_eset_norm)
PCA <- prcomp(t(exp_ribeiro), scale = FALSE)

percentVar <- round(100*PCA$sdev^2/sum(PCA$sdev^2),1)
sd_ratio <- sqrt(percentVar[2] / percentVar[1])

dataGG <- data.frame(PC1 = PCA_raw$x[,1], PC2 = PCA_raw$x[,2],
                     Phenotype = pData(raw_data)$Factor.Value.phenotype.,
                    Individual = pData(raw_data)$Source.Name)


ggplot(dataGG[7:12,], aes(PC1, PC2)) +
      geom_point(aes(colour = Phenotype)) +
  ggtitle("PCA plot of the calibrated, summarized data") +
  xlab(paste0("PC1, VarExp: ", percentVar[1], "%")) +
  ylab(paste0("PC2, VarExp: ", percentVar[2], "%")) +
  theme(plot.title = element_text(hjust = 0.5)) +
  coord_fixed(ratio = sd_ratio) +
  scale_shape_manual(values = c(4,15)) + 
  scale_color_manual(values = c("#EC368D", "#071013"))
```

There is still no clustering of our data even after normalization.


*Heatmap clustering analysis*

We plot a heatmap with the sample-to-sample distances with the sample names as row-names.

For OVCAR8-NV & OVCAR8-C5:
```{r}
phenotype_names <- ifelse(str_detect(pData
                                    (ribeiro_eset_norm)$Factor.Value.phenotype.[1:6],
                             "HE4 overexpression"), "OVCAR8-C5", "OVCAR8-NV")

annotation_for_heatmap <- 
  data.frame(Phenotype = phenotype_names)

row.names(annotation_for_heatmap) <- row.names(pData(ribeiro_eset_norm)[1:6,])


```

```{r}
dists <- as.matrix(dist(t(exp_ribeiro), method = "manhattan"))

rownames(dists) <- row.names(pData(ribeiro_eset_norm))
hmcol <- rev(colorRampPalette(RColorBrewer::brewer.pal(9, "YlOrRd"))(255))
colnames(dists) <- NULL
diag(dists) <- NA

ann_colors <- list(
  Phenotype = c('OVCAR8-C5' = "blue", 'OVCAR8-NV' = "#F17300")
                   )
pheatmap(dists[1:6,1:6], col = (hmcol), 
         annotation_row = annotation_for_heatmap,
         annotation_colors = ann_colors,
         legend = TRUE, 
         treeheight_row = 0,
         legend_breaks = c(min(dists[1:6,1:6], na.rm = TRUE), 
                         max(dists[1:6,1:6], na.rm = TRUE)), 
         legend_labels = (c("small distance", "large distance")),
         main = "Clustering heatmap for the calibrated samples")
```

For OVCAR8-WT vs OVCAR8-WT-rHE4:
```{r}
phenotype_names <- ifelse(str_detect(pData
                                    (ribeiro_eset_norm)$Factor.Value.phenotype.[7:12],
                             "wild type phenotype HE4"), "OVCAR8-WT-rHE4", "OVCAR8-WT")

annotation_for_heatmap <- 
  data.frame(Phenotype = phenotype_names)

row.names(annotation_for_heatmap) <- row.names(pData(ribeiro_eset_norm)[7:12,])


```

```{r}
dists <- as.matrix(dist(t(exp_ribeiro), method = "manhattan"))

rownames(dists) <- row.names(pData(ribeiro_eset_norm))
hmcol <- rev(colorRampPalette(RColorBrewer::brewer.pal(9, "YlOrRd"))(255))
colnames(dists) <- NULL
diag(dists) <- NA

ann_colors <- list(
  Phenotype = c('OVCAR8-WT-rHE4' = "#EC368D", 'OVCAR8-WT' = "green3")
                   )
pheatmap(dists[7:12,7:12], col = (hmcol), 
         annotation_row = annotation_for_heatmap,
         annotation_colors = ann_colors,
         legend = TRUE, 
         treeheight_row = 0,
         legend_breaks = c(min(dists[7:12,7:12], na.rm = TRUE), 
                         max(dists[7:12,7:12], na.rm = TRUE)), 
         legend_labels = (c("small distance", "large distance")),
         main = "Clustering heatmap for the calibrated samples")
```



## Filtering based on intensity

We now filter out lowly expressed genes. Microarray data commonly show a large numberof probes in the background intensity range. These probes also do not change much across arrays. Hence they combine a low variance with a low intensity. Thus, they could end up being detected as differentially expressed although they are barely above the “detection” limit and are not very informative in general.

We will perform a “soft” intensity based filtering here
However, note that a variance based filter might exclude a similar set of probes in practice. For intensity-based filtering, we calculate the row-wise medians from the expression data, as they represent the transcript medians, and assign them to ribiero_medians. From this we create a histogram:

```{r}
ribeiro_medians <- rowMedians(Biobase::exprs(ribeiro_eset_norm))

hist_res <- hist(ribeiro_medians, 100, col = "cornsilk1", freq = FALSE, 
            main = "Histogram of the median intensities", 
            border = "antiquewhite4",
            xlab = "Median intensities")
```

In the histogram of the gene-wise medians, we can clearly see an enrichment of low medians on the left hand side. These represent the genes we want to filter. In order to infer a cutoff from the data, we inspect the histogram: We visually set a cutoff line man_threshold to the left of the histogram peak in order not to exclude too many genes:

```{r}
man_threshold <- 2.5

hist_res <- hist(ribeiro_medians, 100, col = "cornsilk", freq = FALSE, 
            main = "Histogram of the median intensities",
            border = "antiquewhite4",
            xlab = "Median intensities")

abline(v = man_threshold, col = "coral4", lwd = 2)
```


Transcripts that do not have intensities larger than the threshold in at least as many arrays as the smallest experimental group are excluded.

In order to do so, we first have to get a list with the number of samples (=arrays) (no_of_samples) in the experimental groups:

```{r}
no_of_samples <- 
  table(paste0(pData(ribeiro_eset_norm)$Factor.Value.phenotype.))
no_of_samples 
```

We now filter out all transcripts that do not have intensities greater than the threshold in at least as many arrays as the smallest experimental group.
A function idx_man_threshold is then applied to each row, i.e. to each transcript across all arrays. It evaluates whether the number of arrays where the median intensity passes the threshold (sum(x > man_threshold)) is greater than the samples_cutoff and returns TRUE or FALSE for each row, i.e. each transcript.

```{r}
samples_cutoff <- min(no_of_samples)

idx_man_threshold <- apply(Biobase::exprs(ribeiro_eset_norm), 1,
                           function(x){
                          sum(x > man_threshold) >= samples_cutoff})
                          table(idx_man_threshold)
```

```{r}
ribeiro_manfiltered <- subset(ribeiro_eset_norm, idx_man_threshold)
```



## Annotation of the transcript clusters

Before we continue with the linear models for microarrays and differential expression, we first add “feature data”, i.e. annotation information to the transcript cluster identifiers stored in the featureData of our ExpressionSet:

```{r}
anno_ribeiro <- AnnotationDbi::select(hugene10sttranscriptcluster.db,
                                  keys = (featureNames(ribeiro_manfiltered)),
                                  columns = c("SYMBOL", "GENENAME"),
                                  keytype = "PROBEID")

anno_ribeiro <- subset(anno_ribeiro, !is.na(SYMBOL))
```

Many transcript-cluster identifiers will map to multiple gene symbols, i.e. they can’t be unambigously assigned.

We compute a summary table in the code below to see how many there are:

```{r}
anno_grouped <- group_by(anno_ribeiro, PROBEID)
anno_summarized <- 
  dplyr::summarize(anno_grouped, no_of_matches = n_distinct(SYMBOL))

head(anno_summarized)
```

```{r}
anno_filtered <- filter(anno_summarized, no_of_matches > 1)

head(anno_filtered)
```

```{r}
probe_stats <- anno_filtered 

nrow(probe_stats)
```


First, we grouped anno_ribiero by their PROBEID; that way, the subsequent operations are not carried through for each single row, but for each group, i.e. each PROBEID. We then summarized the groups and indicate the number of different genes assigned to a transcript cluster in the column no_of_matches. Finally, we filtered for PROBEIDs with multiple matches, i.e. no_of_matches > 1.

With dim(probe_stats), we could see how many probes have been mapped to multiple genes.

We want to remove those probe IDs that match the ones in probe_stats, as those are the probes with multiple mappings. We assign these IDs to the variable ids_to_exclude. Then, we generate ribiero_final, an expression set without the ids_to_exclude.

```{r}
ids_to_exlude <- (featureNames(ribeiro_manfiltered) %in% probe_stats$PROBEID)

table(ids_to_exlude)
```

```{r}
ribeiro_final <- subset(ribeiro_manfiltered, !ids_to_exlude)

validObject(ribeiro_final)
```

As we have just excluded probe IDs from the assay data, we now have to also exclude them from the feature data anno_ribiero:

```{r}
head(anno_ribeiro)
```

We generate a column PROBEID in fData(ribeiro_final) and assign the row names of fData(ribeiro_final) to it:

```{r}
fData(ribeiro_final)$PROBEID <- rownames(fData(ribeiro_final))
```

Then, we left-join fData(ribeiro_final)with anno_ribeiro, which already contains the columns “SYMBOL” and “GENENAME”. A left-join keeps the rows and columns of the first argument and adds the corresponding column entries of the second argument:

```{r}
fData(ribeiro_final) <- left_join(fData(ribeiro_final), anno_ribeiro)
```

```{r}
# restore rownames after left_join
rownames(fData(ribeiro_final)) <- fData(ribeiro_final)$PROBEID 
    
validObject(ribeiro_final)
```
By left-joining with anno_ribeiro, we thus add the “SYMBOL” and “GENENAME” columns from anno_ribeiro for only the PROBEIDs that are in fData(ribeiro_final) and thus get the feature Data for the filtered probes.



## Linear models

In order to analyse which genes are differentially expressed between our 4 samples, we have to fit a linear model to our expression data.

For the subsequent linear modelling of the data, we introduce the abbreviations “C5” and “NV” for OVCAR8-C5 and OVCAR8-NV, and “WT” and “WT-HE” for OVCAR8-WT-rHE4 and OVCAR8-WT, respectively:

```{r}
individual <- 
  as.character(Biobase::pData(ribeiro_final)$Assay.Name[1:6])

type <- str_replace_all(Biobase::pData(ribeiro_final)$Factor.Value.phenotype.[1:6],
                  " ", "_")

type <- ifelse(type == "HE4_overexpression",
                 "C5", "NV")
```


```{r}
individual_2 <- 
  as.character(Biobase::pData(ribeiro_final)$Assay.Name[7:12])

type_2 <- str_replace_all(Biobase::pData(ribeiro_final)$Factor.Value.phenotype.[7:12],
                  " ", "_")

type_2 <- ifelse(type_2 == "wild_type_phenotype_HE4",
                 "WT-HE", "WT")
```

We create two design matrices, one for each of the two groups we're comparing (C5 vs NV and WT vs WT-rHE4) as we will analyze them separately in order to follow the analysis strategy of the original paper closely:

Note that from here on, when we write C5, we are referring to the first group (C5 vs NV) whereas when we write NV, we are referring to the second group (WT vs WT-rHE4).

```{r}
type=factor(type)
design_ribeiro_C5 <- model.matrix(~ 0 + type)
colnames(design_ribeiro_C5)[1:2] <- c("C5", "NV")
rownames(design_ribeiro_C5) <- individual

type_2=factor(type_2)
design_ribeiro_WT <- model.matrix(~ 0 + type_2)
colnames(design_ribeiro_WT)[1:2] <- c("WT", "WT_HE")
rownames(design_ribeiro_WT) <- individual_2
```

We can inspect the design matrices:
```{r}
head(design_ribeiro_C5)
head(design_ribeiro_WT)
```

Before heading on to find all differentially expressed genes for both diseases, we will first have a look at how this works in principle for one gene. We will fit the linear model for one gene and run a t-test in order to see whether the gene is differentially expressed or not.

For linear model fitting and subsequent testing for differential expression by t-test, we will pick the gene with the PROBEID 7952522. It has the gene symbol PUS3 and will be named as such in the following code.

```{r}
PUS3_expr <- Biobase::exprs(ribeiro_final)["7952522",1:6]
PUS3_data <- as.data.frame(PUS3_expr)
colnames(PUS3_data)[1] <- "org_value"
PUS3_data <- mutate(PUS3_data, type)

PUS3_data$type <- factor(PUS3_data$type, levels = c("C5", "NV"))
```

We now compute the variable coefficients by fitting a linear model. We get a vector PUS3_coef with one entry for each variable:

```{r}
PUS3_coef <- lmFit(ribeiro_final[,1:6], design = design_ribeiro_C5)$coefficients["7952522",]

PUS3_coef
```

In order to now obtain the expression values fitted by the model, we multiply the design matrix with this vector of coefficients PUS3_coef:

```{r}
PUS3_fitted <- design_ribeiro_C5 %*% PUS3_coef
rownames(PUS3_fitted) <- names(PUS3_expr)
colnames(PUS3_fitted) <- "fitted_value"

PUS3_fitted
```

We now conduct the t-test on the linear model in order to find out whether the difference between OVCAR8-C5 and OVCAR8-NV differs significantly from 0:

```{r}
PUS3_C5 <- na.exclude(PUS3_data$org_value[type == "C5"])
PUS3_NV <- na.exclude(PUS3_data$org_value[type == "NV"])
res_t <- t.test(PUS3_C5 ,PUS3_NV , paired = FALSE)
res_t
```

We get a low p-value and thus can conclude that the PUS3 gene is differentially expressed between non-inflamed and inflamed tissue.


We now fit the linear model for all genes and define appropriate contrasts to test hypotheses of interest.

We want to compare the  OVCAR8-C5 to the OVCAR8-NV cells, as well as the  OVCAR8-WT to the OVCAR8-WT-rHE cells. Thus, we create a contrast matrix consisting of only one contrast “NV-C5” and "WT-WT_HE": limma’s function makeContrasts creates this matrix from a symbolic description of the contrast of interest.

We now fit a linear model to our data and apply the contrasts.fit() function to it in order to find genes with significant differential expression:
```{r}
contrast_matrix_C5 <- makeContrasts(NV-C5, levels = design_ribeiro_C5)

ribeiro_fit_C5 <- eBayes(contrasts.fit(lmFit(ribeiro_final[,1:6],
                                design = design_ribeiro_C5),
                                contrast_matrix_C5))

contrast_matrix_WT <- makeContrasts(WT-WT_HE, levels = design_ribeiro_WT)

ribeiro_fit_WT <- eBayes(contrasts.fit(lmFit(ribeiro_final[,7:12],
                                design = design_ribeiro_WT),
                                contrast_matrix_WT))
```


*Extracting results*

Finally, we extract the number of differentially expressed genes. Results can be extracted by use of the topTable function.
We do this for each of our groups:

C5 vs NV:
```{r}
table_C5 <- topTable(ribeiro_fit_C5, number = Inf)
head(table_C5)
```

```{r}
hist(table_C5$P.Value, col = brewer.pal(3, name = "Set2")[1],
     main = "C5 vs NV", xlab = "p-values")
```

Here we see that the p-value distribution isn't very skewed to the right, which can be explained by the fact that we're only comparing 3 samples; we need a larger n to be able to get lower p-values.


WT vs WT-HE:
```{r}
table_WT <- topTable(ribeiro_fit_WT, number = Inf)
head(table_WT)
```

```{r}
hist(table_WT$P.Value, col = brewer.pal(3, name = "Set2")[2],
     main = "WT vs WT-HE", xlab = "p-values")
```

Here (too) we see that the p-value distribution isn't very skewed to the right, which can be explained by the fact that we're only comparing 3 samples; we need a larger n to be able to get lower p-values.


In the original paper, a p-value of 0.05 was used as a significance cutoff. Using this we get 2239 genes identified as differentially expressed C5-NV and 2554 for WT-WT_HE:
```{r}
nrow(subset(table_C5, P.Value < 0.05))
nrow(subset(table_WT, P.Value < 0.05))
```


Looking at table_C5 and table_WT, we see that the log(FC) was calculated instead of just Fold Change, which is what's done in the paper, so we apply a function that will transform our log(FC) values to FC:
```{r}
transform = function(val)
{
  if (val >0)
  {val = 1/(2^-val)}
  else
    val = -1/(2^val)
}
table_C5[,"logFC"]=sapply(table_C5[,"logFC"], transform)
colnames(table_C5)[4]="Fold change (NV/C5)"

table_WT[,"logFC"]=sapply(table_WT[,"logFC"], transform)
colnames(table_WT)[4]="Fold change (WT/WT-rHE)"
```


In table 1 (A) and (B) in the paper, they identified the top 15 differentially expressed genes in either direction (upregulated or downregulated) for each of the 2 groups, so this is what we do here:

First, sort the tables by the FC column:
```{r}
order_C5=order(table_C5$"Fold change (NV/C5)",na.last=TRUE)
sorted_C5=table_C5[order_C5,]

order_WT=order(table_WT$"Fold change (WT/WT-rHE)",na.last=TRUE)
sorted_WT=table_WT[order_WT,]
```

```{r}
upreg_C5=head(na.exclude(sorted_C5), 15)
downreg_C5=tail(na.exclude(sorted_C5), 15)
table_A=rbind(upreg_C5, downreg_C5)
table_A=apply(table_A,2,rev)
table_A
```

```{r}
upreg_WT=head(na.exclude(sorted_WT), 15)
downreg_WT=tail(na.exclude(sorted_WT), 15)
table_B=rbind(upreg_WT, downreg_WT)
table_B=apply(table_B,2,rev)
table_B
```

Looking at Table 1, we can see that (A) is very close to our table_A and (B) is very close to our table_B.


We now calculate the total number of differentially expressed genes that we find in our workflow analysis. We find the overlap between our work and the data given in the supplementary data of the paper.
Not only do we take the p-value cutoff given by the paper (0.05), but we also take the minimum fold change the paper follows (1.5). We do this in both directions: we find genes with FC greater than 1.5 and genes with FC less than -1.5.

First, for C5 vs NV:
```{r}
ribeiro_genes_C5 <- sapply(1:1, function(i) read.xlsx(cols = 4, "C:/Users/ooo/Desktop/k/Uni/Fall 2020/Functional Genomics/Project 1/data_sheet_1.xlsx", sheet = i, startRow = 1))

names(ribeiro_genes_C5) <- c("C5-NV")
ribeiro_genes_C5 <- lapply(ribeiro_genes_C5, as.character)

overlap_C5 <- length(intersect(subset(table_C5, P.Value < 0.05 & (`Fold change (NV/C5)`>1.5 | `Fold change (NV/C5)`< -1.5))$SYMBOL,  
                               ribeiro_genes_C5$`C5-NV`)) / length(ribeiro_genes_C5$`C5-NV`)


overlap_C5
```

Second, for WT vs WT-HE:
```{r}
ribeiro_genes_WT <- sapply(2:2, function(i) read.xlsx(cols = 4, "C:/Users/ooo/Desktop/k/Uni/Fall 2020/Functional Genomics/Project 1/data_sheet_1.xlsx", sheet = i, startRow = 1))

names(ribeiro_genes_WT) <- c("WT-WT_rHE")
ribeiro_genes_WT <- lapply(ribeiro_genes_WT, as.character)

overlap_WT <- length(intersect(subset(table_WT, P.Value < 0.05 & (`Fold change (WT/WT-rHE)`>1.5 | `Fold change (WT/WT-rHE)`< -1.5))$SYMBOL,  
                               ribeiro_genes_WT$`WT-WT_rHE`)) / length(ribeiro_genes_WT$`WT-WT_rHE`)


overlap_WT
```

Finding how many differentially expressed genes for each based on the cutoff value of the paper (0.05).
```{r}
total_genenumber_C5 <- length(subset(table_C5, P.Value < 0.05)$SYMBOL)
total_genenumber_WT <- length(subset(table_WT, P.Value < 0.05)$SYMBOL)

total_genenumber_C5
total_genenumber_WT
```


*Visualization of DE analysis results - volcano plot*

For a visualization of the differentially expressed genes, we create a volcano plot, which is commonly used to summarize the results of a differential expression analysis in a single figure.

For C5 - NV:
```{r}
volcano_names <- ifelse(abs(ribeiro_fit_C5$coefficients)>=1, 
                        ribeiro_fit_C5$genes$SYMBOL, NA)
             
             
volcanoplot(ribeiro_fit_C5, coef = 1L, style = "p-value", highlight = 100, 
            names = volcano_names,
            xlab = "Log2 Fold Change", ylab = NULL, pch=16, cex=0.35)
```

For WT - rHE4:
```{r}
volcano_names_2 <- ifelse(abs(ribeiro_fit_WT$coefficients)>=1, 
                        ribeiro_fit_WT$genes$SYMBOL, NA)
             
             
volcanoplot(ribeiro_fit_WT, coef = 1L, style = "p-value", highlight = 100, 
            names = volcano_names_2,
            xlab = "Log2 Fold Change", ylab = NULL, pch=16, cex=0.35)
```




## Gene ontology (GO) based enrichment analysis

For the following enrichment analysis, we create tables with differentially expressed genes for C5-NV and WT-WT_HE, respectively, and choose an FDR cutoff of 5%.

```{r}
DE_genes_C5 <- subset(table_C5, adj.P.Val < 0.05)$PROBEID
DE_genes_WT <- subset(table_WT, adj.P.Val < 0.05)$PROBEID
```


The function genefinder from the genefilter package (21) will be used to find a background set of genes that are similar in expression to the differentially expressed genes. We then check whether the background has roughly the same distribution of average expression strength as the foreground.

We do this in order not to select a biased background since the gene set testing is performed by a simple Fisher test on a 2x2 table. Note that this approach is very similar to commonly used web tools like GOrilla (22).

For every differentially expressed gene, we try to find genes with similar expression with genefinder. The genefinder function returns a list with two elements for each gene: one with the indices of the background genes found and one with the distances to the DE-genes:
```{r}
back_genes_idx <- genefilter::genefinder(ribeiro_final[,1:6], 
                                        as.character(DE_genes_C5), 
                                        method = "manhattan", scale = "none")
back_genes_idx_2 <- genefilter::genefinder(ribeiro_final[,7:12], 
                                        as.character(DE_genes_WT), 
                                        method = "manhattan", scale = "none")

```

We have to extract the PROBEIDs, which correspond to the indices. We do that by using the sapply function, which gives us a single matrix with the DE-genes as column names and the PROBEIDs of the corresponding background genes in the cells below:

```{r}
back_genes_idx <- sapply(back_genes_idx, function(x)x$indices)
back_genes_idx_2 <- sapply(back_genes_idx_2, function(x)x$indices)
```


We then create a vector back_genes containing all background gene PROBEIDs:

In order to eliminate foreground genes, i.e. DE-genes, from the back_genes set, we use the setdiff function. It returns all elements from the first argument (back_genes) that are not part of the second argument (DE_genes_C5). With the intersect function, we verify that we were successful: it should return 0, as there shouldn’t be any intersect anymore between back_genesand DE_genes_C5:

```{r}
back_genes <- featureNames(ribeiro_final[,1:6])[back_genes_idx]
back_genes <- setdiff(back_genes, DE_genes_C5)

back_genes_2 <- featureNames(ribeiro_final[,7:12])[back_genes_idx_2]
back_genes_2 <- setdiff(back_genes_2, DE_genes_WT)

intersect(back_genes, DE_genes_C5)
intersect(back_genes_2, DE_genes_WT)
```

```{r}
length(back_genes)
length(back_genes_2)
```

We create a multidensity plot with mean expression on the x-axis and curves for all genes, foreground genes and background genes, respectively. We want to see whether the background genes show a plot similar to the foreground genes so that the background is not biased for the gene enrichment analysis:

```{r}
multidensity(list(
        all = table_C5[,"AveExpr"] ,
        fore = table_C5[DE_genes_C5 , "AveExpr"],
        back = table_C5[rownames(table_C5) %in% back_genes, "AveExpr"]),
        col = c("#e46981", "#ae7ee2", "#a7ad4a"),
     xlab = "mean expression",
   main = "DE genes for C5/NV-background-matching")
```
```{r}
multidensity(list(
        all = table_WT[,"AveExpr"] ,
        fore = table_WT[DE_genes_WT , "AveExpr"],
        back = table_WT[rownames(table_WT) %in% back_genes_2, "AveExpr"]),
        col = c("#e46981", "#ae7ee2", "#a7ad4a"),
     xlab = "mean expression",
   main = "DE genes for WT/rHE4-background-matching")
```


*Running topGO*

topGO requires a topGOdata object containing the necessary information for the analysis. We follow the steps described in the topGO vignettes: First, we will create a named vector all_genes with all genes to be analyzed:

```{r}
gene_IDs_C5 <- rownames(table_C5)
in_universe <- gene_IDs_C5 %in% c(DE_genes_C5, back_genes)
in_selection <- gene_IDs_C5 %in% DE_genes_C5

all_genes_C5 <- in_selection[in_universe]
all_genes_C5 <- factor(as.integer(in_selection[in_universe]))
names(all_genes_C5) <- gene_IDs_C5[in_universe] 
```

```{r}
gene_IDs_WT <- rownames(table_WT)
in_universe_2 <- gene_IDs_WT %in% c(DE_genes_WT, back_genes_2)
in_selection_2 <- gene_IDs_WT %in% DE_genes_WT

all_genes_WT <- in_selection_2[in_universe_2]
all_genes_WT <- factor(as.integer(in_selection_2[in_universe_2]))
names(all_genes_WT) <- gene_IDs_WT[in_universe_2] 
```

We now initialize the topGO data set, using the GO annotations contained in the annotation data base for the chip we are using. The nodeSize parameter specifies a minimum size of a GO category we want to use: i.e. here, categories with less than 10 genes are not included in the testing.

```{r}
top_GO_data_C5 <- new("topGOdata", ontology = "BP", allGenes = all_genes_C5,
 nodeSize = 10, annot = annFUN.db, affyLib = "hugene10sttranscriptcluster.db")

top_GO_data_WT <- new("topGOdata", ontology = "BP", allGenes = all_genes_WT,
 nodeSize = 10, annot = annFUN.db, affyLib = "hugene10sttranscriptcluster.db")
```


We run two common tests: an ordinary Fisher test for every GO category, and the “elim” algorithm, which tries to incorporate the hierarchical structure of the GO and tries to “decorrelate” it in order to report the most specific significant term in the hierarchy.

The algorithm starts processing the nodes / GO categories from the highest (bottommost) level and then iteratively moves to nodes from a lower level. If a node is scored as significant, all of its genes are marked as removed in all ancestor nodes. This way, the “elim” algorithm aims at finding the most specific node for every gene.

The test uses a 0.01 p-value cutoff by default.

```{r}
result_top_GO_elim_C5 <- 
  runTest(top_GO_data_C5, algorithm = "elim", statistic = "Fisher")
result_top_GO_classic_C5 <- 
  runTest(top_GO_data_C5, algorithm = "classic", statistic = "Fisher")
```
```{r}
result_top_GO_elim_WT <- 
  runTest(top_GO_data_WT, algorithm = "elim", statistic = "Fisher")
result_top_GO_classic_WT <- 
  runTest(top_GO_data_WT, algorithm = "classic", statistic = "Fisher")
```


We can now inspect the results. We look at the top 100 GO categories according to the “Fisher elim” algorithm. The function GenTable produces a table of significant GO categories, the function printGenes gives genes annotated to them; the significant ones are denoted with a “2” in the “raw p-value” column, the non-significant ones with a “1”. We therefore select raw p-value == 2.


```{r}
res_top_GO_C5 <- GenTable(top_GO_data_C5, Fisher.elim = result_top_GO_elim_C5,
        Fisher.classic = result_top_GO_classic_C5,
        orderBy = "Fisher.elim" , topNodes = 100)

genes_top_GO_C5 <- printGenes(top_GO_data_C5, whichTerms = res_top_GO_C5$GO.ID,
    chip = "hugene10sttranscriptcluster.db", geneCutOff = 1000)

res_top_GO_C5$sig_genes <- sapply(genes_top_GO_C5, function(x){
                str_c(paste0(x[x$'raw p-value' == 2, "Symbol.id"],";"), 
                      collapse = "")
    })

head(res_top_GO_C5[,1:8], 20)
```

```{r}
res_top_GO_WT <- GenTable(top_GO_data_WT, Fisher.elim = result_top_GO_elim_WT,
        Fisher.classic = result_top_GO_classic_WT,
        orderBy = "Fisher.elim" , topNodes = 100)

genes_top_GO_WT <- printGenes(top_GO_data_WT, whichTerms = res_top_GO_WT$GO.ID,
    chip = "hugene10sttranscriptcluster.db", geneCutOff = 1000)

res_top_GO_WT$sig_genes <- sapply(genes_top_GO_WT, function(x){
                str_c(paste0(x[x$'raw p-value' == 2, "Symbol.id"],";"), 
                      collapse = "")
    })

head(res_top_GO_WT[,1:8], 20)
```


Visualization of the GO-analysis results:

A graph of the results can also be produced. Here we visualize the three most significant nodes according to the Fisher elim algorithm in the context of the GO hierarchy.

```{r}
showSigOfNodes(top_GO_data_C5, score(result_top_GO_elim_C5), firstSigNodes = 3,
                useInfo = 'def')
```

```{r}
showSigOfNodes(top_GO_data_WT, score(result_top_GO_elim_WT), firstSigNodes = 3,
                useInfo = 'def')
```



## A pathway enrichment analysis using reactome

The package ReactomePA offers the possibility to test enrichment of specific pathways using the free, open-source, curated and peer reviewed Reactome pathway database. The package requires entrez identifiers, so we convert our PROBEIDs (transcript cluster identifiers) to entrez identifiers using the function mapIDs from the package AnnotationDbi. This will create a named vector that maps the PROBEIDs to the entrez ones, with the PROBEIDs as names and the entrez ids as vector elements.

```{r}
entrez_ids_C5 <- mapIds(hugene10sttranscriptcluster.db, 
      keys = rownames(table_C5), 
      keytype = "PROBEID",
      column = "ENTREZID")
```
```{r}
entrez_ids_WT <- mapIds(hugene10sttranscriptcluster.db, 
      keys = rownames(table_WT), 
      keytype = "PROBEID",
      column = "ENTREZID")
```

We can now run the enrichment analysis that performs a statistical test based on the hypergeoemtric distribution that is the same as a one sided Fisher-test, which topGO calls “Fisher-classic”. Details can be found in the vignette of the DOSE package (26).

```{r}
reactome_enrich_C5 <- enrichPathway(gene = entrez_ids_C5[DE_genes_C5], 
                                universe = entrez_ids_C5[c(DE_genes_C5, 
                                                        back_genes)],
                                organism = "human",
                                pvalueCutoff = 0.05,
                                qvalueCutoff = 0.9, 
                                readable = TRUE)

reactome_enrich_C5@result$Description <- paste0(str_sub(
                                    reactome_enrich_C5@result$Description, 1, 20),
                                    "...")

head(as.data.frame(reactome_enrich_C5@result))[1:6]
```

```{r}
reactome_enrich_WT <- enrichPathway(gene = entrez_ids_WT[DE_genes_WT], 
                                universe = entrez_ids_WT[c(DE_genes_WT, 
                                                        back_genes_2)],
                                organism = "human",
                                pvalueCutoff = 0.05,
                                qvalueCutoff = 0.9, 
                                readable = TRUE)

reactome_enrich_WT@result$Description <- paste0(str_sub(
                                    reactome_enrich_WT@result$Description, 1, 20),
                                    "...")

head(as.data.frame(reactome_enrich_WT@result))[1:6]
```

Visualizing the reactome based analysis results:

```{r}
barplot(reactome_enrich_C5)
```
Since all p-values in reactome_enrich_C5 are greater than the cutoff, it will be empty.

```{r}
barplot(reactome_enrich_WT)
```


The “enrichment map” from the package enrichplot displays the results of the enrichment analysis as a graph, where the color represents the p-value of the pathway and the edge-thickness (that is the line connecting two pathways) is proportional to the number of overlapping genes between two pathways.

Running it on C5: `emapplot(reactome_enrich_C5, showCategory = 10)` gives us the following error:
```{r}
#Error in emapplot.enrichResult(x, showCategory = showCategory, color = color, : no enriched term found...
```

```

However, in WT, since we have data, we get a graph:
```{r}
emapplot(reactome_enrich_WT, showCategory = 10)
```